/* Automatically generated by Kelbt from "lmparse.kh".
 *
 * Parts of this file are copied from Kelbt source covered by the GNU
 * GPL. As a special exception, you may use the parts of this file copied
 * from Kelbt source without restriction. The remainder is derived from
 * "lmparse.kh" and inherits the copyright status of that file.
 */

#line 1 "lmparse.kh"
/*
 *  Copyright 2001-2007 Adrian Thurston <thurston@complang.org>
 */

/*  This file is part of Colm.
 *
 *  Colm is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 * 
 *  Colm is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with Colm; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */

#ifndef RLPARSE_H
#define RLPARSE_H

#include <iostream>
#include "avltree.h"
#include "parsedata.h"

struct Parser
{
	#line 65 "lmparse.kh"


	#line 44 "lmparse.h"
	struct Parser_Block *block;
	struct Parser_LangEl *freshEl;
	int freshPos;
	struct Parser_LangEl *pool;
	int numRetry;
	int numNodes;
	struct Parser_LangEl *stackTop;
	struct Parser_LangEl *lastFinal;
	int errCount;
	int curs;
#line 68 "lmparse.kh"

	void init();
	int parseLangEl( int type, const Token *token );

	Parser( const char *fileName, const char *sectionName, const InputLoc &sectionLoc )
		: sectionName(sectionName), enterRl(false)
	{
		pd = new ParseData( fileName, sectionName, sectionLoc, std::cout );
	}

	int token( InputLoc &loc, int tokId, char *tokstart, int toklen );
	void addRegularDef( const InputLoc &loc, Namespace *nspace, 
		const String &name, JoinOrLm *joinOrLm, bool isInstance );
	void addProduction( const InputLoc &loc, const String &name, 
		ProdElList *prodElList, bool commit, CodeBlock *redBlock, KlangEl *predOf );
	void addArgvList();

	/* Report an error encountered by the parser. */
	ostream &parse_error( int tokId, Token &token );

	ParseData *pd;

	/* The name of the root section, this does not change during an include. */
	const char *sectionName;

	NameRef nameRef;
	NameRefList nameRefList;

	KlangElVect langElVect;

	PatternItemList *patternItemList;
	ReplItemList *replItemList;
	RegionVect regionStack;
	NamespaceVect namespaceStack;
	ContextVect contextStack;

	String curDefineId;
	ProdElList *curProdElList;

	PredType predType;
	ReCaptureVect reCaptureVect;

	bool enterRl;
};

#line 101 "lmparse.h"
#define TK_Word 128
#define TK_Literal 129
#define TK_SingleLit 130
#define TK_DoubleLit 131
#define TK_Number 132
#define TK_UInt 133
#define TK_Hex 134
#define KW_Nil 135
#define KW_True 136
#define KW_False 137
#define TK_DotDot 138
#define TK_ColonGt 139
#define TK_ColonGtGt 140
#define TK_LtColon 141
#define TK_DoubleArrow 142
#define TK_StarStar 143
#define TK_NameSep 144
#define TK_DashDash 145
#define TK_DoubleEql 146
#define TK_NotEql 147
#define TK_DoubleColon 148
#define TK_LessEql 149
#define TK_GrtrEql 150
#define TK_RightArrow 151
#define TK_LitPat 152
#define TK_AmpAmp 153
#define TK_BarBar 154
#define TK_SqOpen 155
#define TK_SqOpenNeg 156
#define TK_SqClose 157
#define TK_Dash 158
#define TK_ReChar 159
#define TK_LtLt 160
#define KW_Rl 161
#define KW_Def 162
#define KW_Lex 163
#define KW_Context 164
#define KW_Ignore 165
#define KW_Token 166
#define KW_Commit 167
#define KW_Namespace 168
#define KW_Literal 169
#define KW_ReduceFirst 170
#define KW_Map 171
#define KW_List 172
#define KW_Vector 173
#define KW_Accum 174
#define KW_Global 175
#define KW_Iter 176
#define KW_Reject 177
#define KW_Ptr 178
#define KW_Ref 179
#define KW_Deref 180
#define KW_If 181
#define KW_While 182
#define KW_Else 183
#define KW_Elsif 184
#define KW_For 185
#define KW_Return 186
#define KW_Yield 187
#define KW_In 188
#define KW_Break 189
#define KW_PrintXMLAC 190
#define KW_PrintXML 191
#define KW_Print 192
#define KW_PrintStream 193
#define KW_Require 194
#define KW_Match 195
#define KW_Construct 196
#define KW_Parse 197
#define KW_ParseStop 198
#define KW_New 199
#define KW_MakeToken 200
#define KW_MakeTree 201
#define KW_TypeId 202
#define KW_Include 203
#define KW_Preeof 204
#define KW_Left 205
#define KW_Right 206
#define KW_Nonassoc 207
#define KW_Prec 208
#define Parser_tk_eof 209

#line 114 "lmparse.kh"

#endif
